# toolchain

- 下载基础脚本 \
`wget https://codechina.csdn.net/codefast/toolchain/-/raw/master/download_toolchain.sh`

- 查看toolchain列表 \
`bash download_toolchain.sh -l` \
`bash download_toolchain.sh -list`

- 下载某版本toolchain \
`bash download_toolchain.sh gcc-arm-8.3-2019.03-x86_64-aarch64-linux-gnu` 8.3官方版本 \
`bash download_toolchain.sh 8.3 aarch64 mini.patch5` 8.3裁减版本(tar.gz=38MB) \
`bash download_toolchain.sh qnx 5.4 mini` QNX7.0-gcc5.4版本

- source toolchain \
`source gcc-***/script/setup_env.sh` 安静模式 \
`source gcc-***/script/setup_env.sh info` info模式


- 自动检测(如果外部配置source toolchain,将不下载和souce;反之下载和source) \
`# download toolchain && Source toolchain` \
`gcc_target=$(${CXX} -v 2>&1 | grep Target | cut -d " " -f 2 | sed 's/linux-gnu/linux/g' | sed 's/unknown-nto-qnx/qnx/g')` \
`if [[ ! "${gcc_target}" =~ "aarch64-linux" ]] ; then` \
`	mkdir -p toolchain/gcc_aarch64_linux` \
`	cd toolchain/gcc_aarch64_linux` \
`		# find history, or download_toolchain` \
`		if [ ! -n "$(find . -name setup_env.sh -type f)" ]; then` \
`			wget https://codechina.csdn.net/codefast/toolchain/-/raw/master/download_toolchain.sh` \
`			bash download_toolchain.sh aarch64 linux` \
`		fi` \
`		# source` \
`		source gcc-***/script/setup_env.sh` \
`		# return` \
`		cd ../..` \
`fi` \
\
`# download toolchain && Source toolchain` \
`gcc_target=$(${CXX} -v 2>&1 | grep Target | cut -d " " -f 2 | sed 's/linux-gnu/linux/g' | sed 's/unknown-nto-qnx/qnx/g')` \
`if [[ ! "${gcc_target}" =~ "aarch64-qnx" ]] ; then` \
`	mkdir -p toolchain/gcc_aarch64_qnx` \
`	cd toolchain/gcc_aarch64_qnx` \
`		# find history, or download_toolchain` \
`		if [ ! -n "$(find . -name setup_env.sh -type f)" ]; then` \
`			wget https://codechina.csdn.net/codefast/toolchain/-/raw/master/download_toolchain.sh` \
`			bash download_toolchain.sh aarch64 qnx mini` \
`		fi` \
`		# source` \
`		source gcc-***/script/setup_env.sh` \
`		# return` \
`		cd ../..` \
`fi` \
